#ifndef CPT_H
#define CPT_H

#include <cptutils/cpt-fill.h>

#include <stdbool.h>

typedef struct
{
  double val;
  cpt_fill_t fill;
} cpt_sample_t;

typedef enum {both, lower, upper, none} annote_t;

typedef struct cpt_seg_t
{
  struct cpt_seg_t *lseg, *rseg;
  cpt_sample_t lsmp, rsmp;
  annote_t annote;
  char *label;
} cpt_seg_t;

typedef struct
{
  char *name;
  model_t model, interpolate;
  cpt_fill_t fg, bg, nan;
  cpt_seg_t *segment;
} cpt_t;

cpt_t* cpt_new();
void cpt_destroy(cpt_t*);

int cpt_prepend(cpt_seg_t*, cpt_t*);
int cpt_append(cpt_seg_t*, cpt_t*);

cpt_seg_t* cpt_pop(cpt_t*);
cpt_seg_t* cpt_shift(cpt_t*);

cpt_seg_t* cpt_seg_new(void);
void cpt_seg_destroy(cpt_seg_t*);

int cpt_nseg(const cpt_t*);
bool cpt_increasing(const cpt_t*);
int cpt_zrange(const cpt_t*, double[static 2]);


#endif
