#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "cptutils/css3.h"
#include "cptutils/btrace.h"

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

css3_t* css3_new(void)
{
  css3_t *css3;

  if ((css3 = malloc(sizeof(css3_t))) == NULL)
    {
      btrace("failed memory allocation");
      return NULL;
    }

  css3->angle = 0.0;
  css3->n     = 0;
  css3->stop  = NULL;

  return css3;
}

/* this can only be done once */

int css3_stops_alloc(css3_t *css3, int n)
{
  css3_stop_t *stop;

  if (n<1) return 1;

  if (css3->n > 0) return 1;

  if ((stop = malloc(n*sizeof(css3_stop_t))) == NULL)
    {
      btrace("failed memory allocation");
      return 1;
    }

  css3->n     = n;
  css3->stop  = stop;

  return 0;
}

void css3_destroy(css3_t *css3)
{
  if (css3->n) free(css3->stop);
  free(css3);
}
